



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>【转】C++中的虚函数的实现</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">【转】C++中的虚函数的实现</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-24 19:23:17 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>转自：<a href="http://blog.csdn.net/haoel/article/details/1948051" rel="external nofollow noreferrer">http://blog.csdn.net/haoel/article/details/1948051</a></p>
<p>对C++ 了解的人都应该知道虚函数（Virtual Function）是通过一张虚函数表（Virtual Table）来实现的。简称为V-Table。 在这个表中，主是要一个类的虚函数的地址表，这张表解决了继承、覆盖的问题，保证其容真实反应实际的函数。这样，在有虚函数的类的实例中这个表被分配在了 这个实例的内存中，所以，当我们用父类的指针来操作一个子类的时候，这张虚函数表就显得由为重要了，它就像一个地图一样，指明了实际所应该调用的函数。</p>
<p><strong>1. 基本的虚函数表</strong></p>
<p>这里我们着重看一下这张虚函数表。C++的编译器应该是保证虚函数表的指针存在于对象实例中最前面的位置（这是为了保证取到虚函数表的有最高的性能&mdash;&mdash;如果有多层继承或是多重继承的情况下）。这意味着我们通过对象实例的地址得到这张虚函数表，然后就可以遍历其中函数指针，并调用相应的函数。</p>
<p>听我扯了那么多，我可以感觉出来你现在可能比以前更加晕头转向了。没关系，下面就是实际的例子，相信聪明的你一看就明白了。</p>
<p>假设我们有这样的一个类：</p>
<div>
<pre class="prettyprint linenums">class Base {<br />
     public:<br />
            virtual void f() { cout &lt;&lt; "Base::f" &lt;&lt; endl; }<br />
            virtual void g() { cout &lt;&lt; "Base::g" &lt;&lt; endl; }<br />
            virtual void h() { cout &lt;&lt; "Base::h" &lt;&lt; endl; }<br />
};
</pre>
</div>
<p>按照上面的说法，我们可以通过Base的实例来得到虚函数表。下面是实际例程：</p>
<div>
<pre class="prettyprint linenums">typedef void(*Fun)(void);<br />
Base b;<br />
Fun pFun = NULL;<br />
cout &lt;&lt; "虚函数表地址：" &lt;&lt; (int*)(&amp;b) &lt;&lt; endl;<br />
cout &lt;&lt; "虚函数表 &mdash; 第一个函数地址：" &lt;&lt; (int*)*(int*)(&amp;b) &lt;&lt; endl;

// Invoke the first virtual function<br />
pFun = (Fun)*((int*)*(int*)(&amp;b));<br />
pFun();
</pre>
</div>
<p>实际运行经果如下：(Windows XP+VS2003,&nbsp; Linux 2.6.22 + GCC 4.1.3)</p>
<p>虚函数表地址：0012FED4</p>
<p>虚函数表 &mdash; 第一个函数地址：0044F148</p>
<p>Base::f</p>
<p>通过这个示例，我们可以看到，我们可以通过强行把&amp;b转成int *，取得虚函数表的地址，然后，再次取址就可以得到第一个虚函数的地址了，也就是Base::f()，这在上面的程序中得到了验证（把int* 强制转成了函数指针）。通过这个示例，我们就可以知道如果要调用Base::g()和Base::h()，其代码如下：</p>
<div>
<pre class="prettyprint linenums">(Fun)*((int*)*(int*)(&amp;b)+0);  // Base::f()<br />
(Fun)*((int*)*(int*)(&amp;b)+1);  // Base::g()<br />
(Fun)*((int*)*(int*)(&amp;b)+2);  // Base::h()
</pre>
</div>
<p>这个时候你应该懂了吧。什么？还是有点晕。也是，这样的代码看着太乱了。没问题，让我画个图解释一下。如下所示：</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/437053/201311/01105001-7eaee9834a064e64b8dbdfcd81f83726.jpg" /></p>
<p>注意：在上面这个图中，我在虚函数表的最后多加了一个结点，这是虚函数表的结束结点，就像字符串的结束符&ldquo;/0&rdquo;一样，其标志了虚函数表的结束。这个结束标志的值在不同的编译器下是不同的。在WinXP+VS2003下，这个值是NULL。而在Ubuntu 7.10 + Linux 2.6.22 + GCC 4.1.3下，这个值是如果1，表示还有下一个虚函数表，如果值是0，表示是最后一个虚函数表。</p>
<p>下面，我将分别说明&ldquo;无覆盖&rdquo;和&ldquo;有覆盖&rdquo;时的虚函数表的样子。没有覆盖父类的虚函数是毫无意义的。我之所以要讲述没有覆盖的情况，主要目的是为了给一个对比。在比较之下，我们可以更加清楚地知道其内部的具体实现。</p>
<p><strong>2. 一般继承中的虚函数表（虚函数无重载）</strong></p>
<p>下面，再让我们来看看继承时的虚函数表是什么样的。假设有如下所示的一个继承关系：</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/437053/201311/01105200-135ca8de7b69401d9fd0dab53e629979.jpg" /></p>
<p>请注意，在这个继承关系中，子类没有重载任何父类的函数。那么，在派生类的实例中，其虚函数表如下所示：(对于实例：Derive d; 的虚函数表如下：)</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/437053/201311/01105230-fe751542d2d741398deb1e2153a97996.jpg" /></p>
<p>我们可以看到下面几点：</p>
<p>1）虚函数按照其声明顺序放于表中。</p>
<p>2）父类的虚函数在子类的虚函数前面。</p>
<p>我相信聪明的你一定可以参考前面的那个程序，来编写一段程序来验证。</p>
<p><strong>3. 一般继承（有虚函数重载）</strong></p>
<p>覆盖父类的虚函数是很显然的事情，不然，虚函数就变得毫无意义。下面，我们来看一下，如果子类中有虚函数重载了父类的虚函数，会是一个什么样子？假设，我们有下面这样的一个继承关系。</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/437053/201311/01105527-7c9d82761f2247ad8fc9d3704a2a3811.jpg" /></p>
<p>为了让大家看到被继承过后的效果，在这个类的设计中，我只覆盖了父类的一个函数：f()。那么，对于派生类的实例，其虚函数表会是下面的一个样子：</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/437053/201311/01105602-a22aba43b86645718224d4f757d2b465.jpg" /></p>
<p>我们从表中可以看到下面几点，</p>
<p>1）覆盖的f()函数被放到了虚表中原来父类虚函数的位置。</p>
<p>2）没有被覆盖的函数依旧。</p>
<p>这样，我们就可以看到对于下面这样的程序，</p>
<div>
<pre class="prettyprint linenums">Base *b = new Derive();<br />
b-&gt;f();
</pre>
</div>
<p>由b所指的内存中的虚函数表的f()的位置已经被Derive::f()函数地址所取代，于是在实际调用发生时，是Derive::f()被调用了。这就实现了多态。</p>
<p><strong>4. 多重继承（无虚函数重载）</strong></p>
<p>下面，再让我们来看看多重继承中的情况，假设有下面这样一个类的继承关系。</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/437053/201311/01105821-6fadd2a4eb67424f8cdd6fc871b6f39b.jpg" /></p>
<p>注意：子类并没有覆盖父类的函数。对于子类实例中的虚函数表，是下面这个样子： <img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/437053/201311/01105907-a6e2ae1a5a8341118a37dd2eebf90319.jpg" /></p>
<p>我们可以看到：</p>
<p>1）&nbsp; 每个父类都有自己的虚表。</p>
<p>2）&nbsp; 子类的成员函数被放到了第一个父类的表中。（所谓的第一个父类是按照声明顺序来判断的）</p>
<p>这样做就是为了解决不同的父类类型的指针指向同一个子类实例，而能够调用到实际的函数。</p>
<p><strong>5. 多重继承（有虚函数重载）</strong></p>
<p>下面我们再来看看，如果发生虚函数覆盖的情况。下图中，我们在子类中覆盖了父类的f()函数。</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/437053/201311/01110022-8134d16486894928b813349f4a234ed7.jpg" /></p>
<p>下面是对于子类实例中的虚函数表的图：</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/437053/201311/01110058-97603177f8424ad39774ef7ea02f2fc6.jpg" /></p>
<p>我们可以看见，三个父类虚函数表中的f()的位置被替换成了子类的函数指针。这样，我们就可以任一静态类型的父类来指向子类，并调用子类的f()了。如：</p>
<div>
<pre class="prettyprint linenums">Derive d;<br />
Base1 *b1 = &amp;d;<br />
Base2 *b2 = &amp;d;<br />
Base3 *b3 = &amp;d;<br />
b1-&gt;f(); //Derive::f()<br />
b2-&gt;f(); //Derive::f()<br />
b3-&gt;f(); //Derive::f()<br />
b1-&gt;g(); //Base1::g()<br />
b2-&gt;g(); //Base2::g()<br />
b3-&gt;g(); //Base3::g()
</pre>
</div>
<p><strong>5. 安全性</strong></p>
<p>每次写C++的文章，总免不了要批判一下C++。这篇文章也不例外。通过上面的讲述，相信我们对虚函数表有一个比较细致的了解了。水可载舟，亦可覆舟。下面，让我们来看看我们可以用虚函数表来干点什么坏事吧。</p>
<p><strong>5.1 通过父类型的指针访问子类自己的虚函数</strong></p>
<p>我们知道，子类没有重载父类的虚函数是一件毫无意义的事情。因为多态也是要基于函数重载的。虽然在上面的图中我们可以看到Base1的虚表中有Derive的虚函数，但我们根本不可能使用下面的语句来调用子类的自有虚函数：</p>
<div>
<pre class="prettyprint linenums">Base1 *b1 = new Derive();<br />
b1-&gt;f1();  //编译出错
</pre>
</div>
<p>任何妄图使用父类指针想调用子类中的<strong>未覆盖父类的成员函数</strong>的行为都会被编译器视为非法，所以，这样的程序根本无法编译通过。但在运行时，我们可以通过指针的方式访问虚函数表来达到违反C++语义的行为。（关于这方面的尝试，通过阅读后面附录的代码，相信你可以做到这一点）</p>
<p><strong>5.2 访问non-public</strong><strong>的虚函数</strong></p>
<p>另外，如果父类的虚函数是private或是protected的，但这些非public的虚函数同样会存在于虚函数表中，所以，我们同样可以使用访问虚函数表的方式来访问这些non-public的虚函数，这是很容易做到的。如：</p>
<div>
<pre class="prettyprint linenums">class Base {<br />
    private:<br />
            virtual void f() { cout &lt;&lt; "Base::f" &lt;&lt; endl; }<br />
};

class Derive : public Base{<br />
};

typedef void(*Fun)(void); 

void main() {<br />
    Derive d;<br />
    Fun  pFun = (Fun)*((int*)*(int*)(&amp;d)+0);<br />
    pFun();<br />
}
</pre>
</div>
<p>结束语</p>
<p>C++这门语言是一门Magic的语言，对于程序员来说，我们似乎永远摸不清楚这门语言背着我们在干了什么。需要熟悉这门语言，我们就必需要了解C++里面的那些东西，需要去了解C++中那些危险的东西。不然，这是一种搬起石头砸自己脚的编程语言。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/r8m2e4rq.html">Mpale 在汽车底盘悬架系统公差分析应用</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7ev1j9.html">在MySQL中出现Unknown column &amp;&num;39&semi;abc&amp;&num;39&semi; in &amp;&num;39&semi;field list&amp;&num;39&semi;怎么解决？</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kke658.html">渐析java的浅拷贝和深拷贝</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jolw0q.html">RedHat下安装OPENCV</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmm7v69.html">IOC Container&lpar;服务容器&rpar;的工作机制</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mlddjq.html">gcc命令行详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjgged9.html">一站式Hadoop&amp;amp&semi;Spark云计算分布式大数据和Android&amp;amp&semi;HTML5移动互联网解决方案课程（Hadoop、Spark、Android、HTML5）V2的第一门课程</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oky0g59.html">ListView为什么用setOnItemClick这个方法和onTouch这个方法有冲突</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1z75l49.html">C51指针类型和存储区的关系详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7m6jweq.html">SpringMVC的值传递</a>
		</li>
						<li><a href="https://www.batexi.com/a/96o62249.html">Github实例教程-创建库、创建主页</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jz2wvg8.html">js实现htmlToWordDemo</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzg4d08.html">spring boot热部署</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mev4z2q.html">RobotFramework自动化测试框架的基础关键字（二）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25z65xq.html">python3-知识扩展扫盲易忘-map&comma;collections&period;Counter&lpar;&rpar;的用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1r1do48.html">Meet in the middle学习笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jm06dg9.html">K-means聚类算法的三种改进&lpar;K-means&plus;&plus;&comma;ISODATA&comma;Kernel K-means&rpar;介绍与对比</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gp476e9.html">mysql 开启远程访问</a>
		</li>
						<li><a href="https://www.batexi.com/a/93pg6lr8.html">CSS3实现垂直居中的新方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qve6e2o9.html">ACE服务端编程4：ACE跨平台之运行时初始化和关闭</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9j0g0d4q.html">IOS  接ShareSDK问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rdm5m78.html">MyBatis 学习入门</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvvne0oq.html">Android Service的生命周期</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j0gmg4q.html">python属性查找</a>
			</li>
						<li><a href="https://www.batexi.com/a/qn10nkx8.html">ServletInvocableHandlerMethod&colon;167 - Error resolving argument</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k14oej9.html">C&ZeroWidthSpace;&plus;&ZeroWidthSpace;&plus;&ZeroWidthSpace;默&ZeroWidthSpace;认&ZeroWidthSpace;构&ZeroWidthSpace;造&ZeroWidthSpace;函&ZeroWidthSpace;数</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1z2ppz9.html">Java开发所需架包官方下载</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pjeky79.html">归纳决策树ID3（Java实现）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwdx5mk8.html">JAVA - Blowfish加密出现java&period;security&period;InvalidKeyException&colon; Illegal key size 解决方案</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2wv0k3q.html">Webform和MVC，为什么MVC更好一些？</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
